<template>
    <div class="bg-white">
        <note-header
            :open="isSlideOverMenuOpen"
            @open="handleSlideOverToogle"
            @backToNotebook="handleBackToNotebook"
        ></note-header>
        <slide-over-menu :open="isSlideOverMenuOpen" @close="handleSlideOverToogle"></slide-over-menu>
        <notebook-slide-over :open="isNotebookSlideOverOpen" :current-notebook="notebook"></notebook-slide-over>
        <open-notebook-button :open="isNotebookSlideOverOpen" @open="openNotebookSlideOver"></open-notebook-button>
        <section class="flex justify-center">
            <note-body
                @notebookChange="onNotebookChange"
                @noteChange="onNoteChange"
                :notebook="notebook"
                :note="note"
            ></note-body>
        </section>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'
import { INotebook, INote } from '@/store/types/notebooks'
import SlideOverMenu from '@/app/Editor/components/SlideOverMenu.vue'
import NoteHeader from '@/app/Editor/components/Note/NoteHeader.vue'
import NotebookSlideOver from '@/app/Editor/components/Note/NotebookSlideOver.vue'
import NoteBody from '@/app/Editor/components/Note/NoteBody.vue'
import OpenNotebookButton from '@/app/Editor/components/Note/OpenNotebookButton.vue'
import { offlineDB } from '@/offline/db'
import { Route } from 'vue-router'
import { IRoot } from '@/store/types/root'

@Component({
    components: {
        NoteHeader,
        SlideOverMenu,
        NotebookSlideOver,
        NoteBody,
        OpenNotebookButton,
    },
})
export default class NoteNode extends Vue {
    // Lifecycle

    created() {
        if (!this.$store.state.Notebooks.notebooks) {
            this.$store
                .dispatch('init')
                .then(() => {
                    this.$set(
                        this.$data,
                        'notebook',
                        this.updateNotebook(this.$route)
                    )
                    this.$set(this.$data, 'note', this.updateNote(this.$route))
                })
                .catch(e => {
                    throw new Error(e)
                })
        } else {
            this.$set(this.$data, 'notebook', this.updateNotebook(this.$route))
            this.$set(this.$data, 'note', this.updateNote(this.$route))
        }
    }
    // Data

    isSlideOverMenuOpen: boolean = false
    isNotebookSlideOverOpen: boolean = false
    notebook: INotebook | null = null
    note: INote | null = null

    // State
    @State((state: IRoot) => {
        return state.Notebooks.notebooks
    })
    allNotebooks: INotebook[] | undefined

    // Watch

    @Watch('$route')
    watchRoute(newRoute: Route, oldRoute: Route) {
        this.$set(this.$data, 'notebook', this.updateNotebook(newRoute))
        this.$set(this.$data, 'note', this.updateNote(newRoute))
    }

    @Watch('allNotebooks')
    watchAllNotebooks() {
        this.$set(this.$data, 'notebook', this.updateNotebook(this.$route))
        this.$set(this.$data, 'note', this.updateNote(this.$route))
    }

    // Methods

    handleSlideOverToogle(state: boolean) {
        this.isSlideOverMenuOpen = state
    }

    handleBackToNotebook() {
        if (!this.notebook || !this.notebook.id) return
        const url = `/notebook/${this.notebook.id}/`
        this.$router.push(url)
    }

    openNotebookSlideOver(state: boolean) {
        this.isNotebookSlideOverOpen = state
    }

    // Update Note and Notebooks

    updateNotebook(route: Route): INotebook | null {
        if (this.allNotebooks) {
            const notebook = this.allNotebooks.filter(
                notebook => notebook.id === route.params.NotebookID
            )[0]
            return notebook
        }
        return null
    }

    updateNote(route: Route): INote | null {
        if (this.notebook && this.notebook.notes) {
            const note = this.notebook.notes.filter(
                note => note.id === route.params.NoteID
            )[0]
            return note
        }
        return null
    }

    // Note Events

    async onNoteChange(note: INote) {
        if (!this.notebook || !this.notebook.id) return
        try {
            if (note.id) {
                const url = `/notebook/${this.notebook.id}/${note.id}/`
                await offlineDB.updateNote(note)
            } else {
                const id = await offlineDB.saveNote(note)
                const url = `/notebook/${this.notebook.id}/${id}/`
                if (this.$route.fullPath !== url)
                    this.$router.push(url).catch(error => {
                        throw new Error(error)
                    })
            }
        } catch (error) {
            throw new Error(error)
        }
    }

    async onNotebookChange(payload: { note: INote; notebook: INotebook }) {
        // Setup

        const { note, notebook } = payload
        const url = note.id
            ? `/notebook/${notebook.id}/${note.id}/`
            : `/notebook/${notebook.id}/new-note/`
        // Hitting the same notebook
        if (this.$route.fullPath === url) return
        // Notebook has no id
        if (!notebook.id) return

        // If Note NO note exists

        if (!note) {
            this.$router.push(url)
            return
        }

        // Perform transcation: save not in new notebook & delete in old notebook

        note.notebook = {
            id: notebook.id,
            name: notebook.name,
        }
        try {
            await offlineDB.updateNote(note)
            this.$router.push(url)
        } catch (error) {
            throw new Error(error)
        }
    }
}
</script>